diff mbox series

[3/3] xfs: test adding realtime sections to filesystem

Message ID 163045510141.769915.9334618845276733225.stgit@magnolia (mailing list archive)
State New, archived
Headers show
Series fstests: regression tests for 5.13/5.14 rt fixes | expand

Commit Message

Darrick J. Wong Sept. 1, 2021, 12:11 a.m. UTC
From: Darrick J. Wong <djwong@kernel.org>

Add a functional test to exercise using "xfs_growfs -e XXX -r" to add a
realtime section to a filesystem while changing the extent size.

Signed-off-by: Darrick J. Wong <djwong@kernel.org>
---
 tests/xfs/779     |  112 +++++++++++++++++++++++++++++++++++++++++++++++++++++
 tests/xfs/779.out |    2 +
 2 files changed, 114 insertions(+)
 create mode 100755 tests/xfs/779
 create mode 100644 tests/xfs/779.out

Comments

Eryu Guan Sept. 5, 2021, 2:38 p.m. UTC | #1
On Tue, Aug 31, 2021 at 05:11:41PM -0700, Darrick J. Wong wrote:
> From: Darrick J. Wong <djwong@kernel.org>
> 
> Add a functional test to exercise using "xfs_growfs -e XXX -r" to add a
> realtime section to a filesystem while changing the extent size.
> 
> Signed-off-by: Darrick J. Wong <djwong@kernel.org>
> ---
>  tests/xfs/779     |  112 +++++++++++++++++++++++++++++++++++++++++++++++++++++
>  tests/xfs/779.out |    2 +
>  2 files changed, 114 insertions(+)
>  create mode 100755 tests/xfs/779
>  create mode 100644 tests/xfs/779.out
> 
> 
> diff --git a/tests/xfs/779 b/tests/xfs/779
> new file mode 100755
> index 00000000..f064879c
> --- /dev/null
> +++ b/tests/xfs/779
> @@ -0,0 +1,112 @@
> +#! /bin/bash
> +# SPDX-License-Identifier: GPL-2.0
> +# Copyright (c) 2021 Oracle.  All Rights Reserved.
> +#
> +# FS QA Test 779
> +#
> +# Test for xfs_growfs to make sure that we can add a realtime device and set
> +# its extent size hint at the same time.  This also checks for the presence of
> +# these patches:
> +#
> +#	xfs: improve FSGROWFSRT precondition checking
> +#	xfs: fix an integer overflow error in xfs_growfs_rt
> +#	xfs: correct the narrative around misaligned rtinherit/extszinherit dirs
> +#	xfs: don't expose misaligned extszinherit hints to userspace

The patches are now merged, include their commit ids as well?

> +#
> +. ./common/preamble
> +_begin_fstest auto quick realtime growfs
> +
> +# Import common functions.
> +. ./common/filter
> +
> +# real QA test starts here
> +
> +# Modify as appropriate.
> +_supported_fs generic

_supported_fs xfs

> +_require_realtime
> +_require_scratch
> +
> +# Format scratch fs with no realtime section.
> +SCRATCH_RTDEV="" _scratch_mkfs | _filter_mkfs 2> $tmp.mkfs >> $seqres.full
> +_scratch_mount
> +
> +# Check that there's no realtime section.
> +source $tmp.mkfs
> +test $rtblocks -eq 0 || echo "expected 0 rtblocks, got $rtblocks"
> +
> +# Compute a new rt extent size and a separate rt extent size hint to exercise
> +# the code that ignores hints that aren't a multiple of the extent size.
> +XFS_MAX_RTEXTSIZE=$((1024 * 1024 * 1024))
> +new_rtextsz=$((rtextsz + dbsize))
> +if [ $new_rtextsz -gt $XFS_MAX_RTEXTSIZE ]; then
> +	new_rtextsz=$((rtextsz - dbsize))
> +fi
> +new_rtextsz_blocks=$(( new_rtextsz / dbsize ))
> +
> +new_extszhint=$((rtextsz * 2))
> +if [ $new_extszhint -eq $new_rtextsz ]; then
> +	new_extszhint=$((rtextsz * 3))
> +fi
> +
> +# Set the inheritable extent size hint and rt status.
> +$XFS_IO_PROG -c 'chattr +t' -c "extsize $new_extszhint" $SCRATCH_MNT
> +
> +# Check that the hint was set correctly
> +after_extszhint=$($XFS_IO_PROG -c 'stat' $SCRATCH_MNT | \
> +	grep 'fsxattr.extsize' | cut -d ' ' -f 3)
> +test $after_extszhint -eq $new_extszhint || \
> +	echo "expected extszhint $new_extszhint, got $after_extszhint"
> +
> +# Add a realtime section and change the extent size.
> +echo $XFS_GROWFS_PROG -e $new_rtextsz_blocks -r $SCRATCH_MNT >> $seqres.full
> +$XFS_GROWFS_PROG -e $new_rtextsz_blocks -r $SCRATCH_MNT >> $seqres.full 2> $tmp.growfs
> +res=$?
> +cat $tmp.growfs
> +
> +# If the growfs failed, skip the post-test check because the scratch fs does
> +# not have SCRATCH_RTDEV configured.  If the kernel didn't support adding the
> +# rt volume, skip everything else.
> +if [ $res -ne 0 ]; then
> +	rm -f ${RESULT_DIR}/require_scratch
> +	if grep -q "Operation not supported" $tmp.growfs; then
> +		_notrun "growfs not supported on rt volume"
> +	fi
> +fi
> +
> +# Now that the root directory's extsize hint is no longer aligned to the rt
> +# extent size, check that we don't report it to userspace any more.
> +grow_extszhint=$($XFS_IO_PROG -c 'stat' $SCRATCH_MNT | \
> +	grep 'fsxattr.extsize' | cut -d ' ' -f 3)
> +test $grow_extszhint -eq 0 || \
> +	echo "expected post-grow extszhint 0, got $grow_extszhint"
> +
> +# Check that we now have rt extents.
> +rtextents=$($XFS_IO_PROG -c 'statfs' $SCRATCH_MNT | \
> +	grep 'geom.rtextents' | cut -d ' ' -f 3)
> +test $rtextents -gt 0 || echo "expected rtextents > 0"
> +
> +# Check the new rt extent size.
> +after_rtextsz_blocks=$($XFS_IO_PROG -c 'statfs' $SCRATCH_MNT | \
> +	grep 'geom.rtextsize' | cut -d ' ' -f 3)
> +test $after_rtextsz_blocks -eq $new_rtextsz_blocks || \
> +	echo "expected rtextsize $new_rtextsz_blocks, got $after_rtextsz_blocks"
> +
> +# Create a new realtime file to prove that we can.
> +echo moo > $SCRATCH_MNT/a
> +sync

A global sync is a bit heavy, fsync the file or syncfs $SCRATCH_MNT ?

Thanks,
Eryu

> +$XFS_IO_PROG -c 'lsattr -v' $SCRATCH_MNT/a | \
> +	cut -d ' ' -f 1 | \
> +	grep -q realtime || \
> +	echo "$SCRATCH_MNT/a is not a realtime file?"
> +
> +# Check that the root directory's hint (which was aligned before the grow and
> +# misaligned after) did not propagate to the new realtime file.
> +file_extszhint=$($XFS_IO_PROG -c 'stat' $SCRATCH_MNT/a | \
> +	grep 'fsxattr.extsize' | cut -d ' ' -f 3)
> +test $file_extszhint -eq 0 || \
> +	echo "expected file extszhint 0, got $file_extszhint"
> +
> +# success, all done
> +echo Silence is golden
> +status=0
> +exit
> diff --git a/tests/xfs/779.out b/tests/xfs/779.out
> new file mode 100644
> index 00000000..1f79fae2
> --- /dev/null
> +++ b/tests/xfs/779.out
> @@ -0,0 +1,2 @@
> +QA output created by 779
> +Silence is golden
Darrick J. Wong Sept. 13, 2021, 6:02 p.m. UTC | #2
On Sun, Sep 05, 2021 at 10:38:37PM +0800, Eryu Guan wrote:
> On Tue, Aug 31, 2021 at 05:11:41PM -0700, Darrick J. Wong wrote:
> > From: Darrick J. Wong <djwong@kernel.org>
> > 
> > Add a functional test to exercise using "xfs_growfs -e XXX -r" to add a
> > realtime section to a filesystem while changing the extent size.
> > 
> > Signed-off-by: Darrick J. Wong <djwong@kernel.org>
> > ---
> >  tests/xfs/779     |  112 +++++++++++++++++++++++++++++++++++++++++++++++++++++
> >  tests/xfs/779.out |    2 +
> >  2 files changed, 114 insertions(+)
> >  create mode 100755 tests/xfs/779
> >  create mode 100644 tests/xfs/779.out
> > 
> > 
> > diff --git a/tests/xfs/779 b/tests/xfs/779
> > new file mode 100755
> > index 00000000..f064879c
> > --- /dev/null
> > +++ b/tests/xfs/779
> > @@ -0,0 +1,112 @@
> > +#! /bin/bash
> > +# SPDX-License-Identifier: GPL-2.0
> > +# Copyright (c) 2021 Oracle.  All Rights Reserved.
> > +#
> > +# FS QA Test 779
> > +#
> > +# Test for xfs_growfs to make sure that we can add a realtime device and set
> > +# its extent size hint at the same time.  This also checks for the presence of
> > +# these patches:
> > +#
> > +#	xfs: improve FSGROWFSRT precondition checking
> > +#	xfs: fix an integer overflow error in xfs_growfs_rt
> > +#	xfs: correct the narrative around misaligned rtinherit/extszinherit dirs
> > +#	xfs: don't expose misaligned extszinherit hints to userspace
> 
> The patches are now merged, include their commit ids as well?

Oops, sorry, this one slipped through when I tried to correct all that. :(

> > +#
> > +. ./common/preamble
> > +_begin_fstest auto quick realtime growfs
> > +
> > +# Import common functions.
> > +. ./common/filter
> > +
> > +# real QA test starts here
> > +
> > +# Modify as appropriate.
> > +_supported_fs generic
> 
> _supported_fs xfs

Fixed, thanks.

> > +_require_realtime
> > +_require_scratch
> > +
> > +# Format scratch fs with no realtime section.
> > +SCRATCH_RTDEV="" _scratch_mkfs | _filter_mkfs 2> $tmp.mkfs >> $seqres.full
> > +_scratch_mount
> > +
> > +# Check that there's no realtime section.
> > +source $tmp.mkfs
> > +test $rtblocks -eq 0 || echo "expected 0 rtblocks, got $rtblocks"
> > +
> > +# Compute a new rt extent size and a separate rt extent size hint to exercise
> > +# the code that ignores hints that aren't a multiple of the extent size.
> > +XFS_MAX_RTEXTSIZE=$((1024 * 1024 * 1024))
> > +new_rtextsz=$((rtextsz + dbsize))
> > +if [ $new_rtextsz -gt $XFS_MAX_RTEXTSIZE ]; then
> > +	new_rtextsz=$((rtextsz - dbsize))
> > +fi
> > +new_rtextsz_blocks=$(( new_rtextsz / dbsize ))
> > +
> > +new_extszhint=$((rtextsz * 2))
> > +if [ $new_extszhint -eq $new_rtextsz ]; then
> > +	new_extszhint=$((rtextsz * 3))
> > +fi
> > +
> > +# Set the inheritable extent size hint and rt status.
> > +$XFS_IO_PROG -c 'chattr +t' -c "extsize $new_extszhint" $SCRATCH_MNT
> > +
> > +# Check that the hint was set correctly
> > +after_extszhint=$($XFS_IO_PROG -c 'stat' $SCRATCH_MNT | \
> > +	grep 'fsxattr.extsize' | cut -d ' ' -f 3)
> > +test $after_extszhint -eq $new_extszhint || \
> > +	echo "expected extszhint $new_extszhint, got $after_extszhint"
> > +
> > +# Add a realtime section and change the extent size.
> > +echo $XFS_GROWFS_PROG -e $new_rtextsz_blocks -r $SCRATCH_MNT >> $seqres.full
> > +$XFS_GROWFS_PROG -e $new_rtextsz_blocks -r $SCRATCH_MNT >> $seqres.full 2> $tmp.growfs
> > +res=$?
> > +cat $tmp.growfs
> > +
> > +# If the growfs failed, skip the post-test check because the scratch fs does
> > +# not have SCRATCH_RTDEV configured.  If the kernel didn't support adding the
> > +# rt volume, skip everything else.
> > +if [ $res -ne 0 ]; then
> > +	rm -f ${RESULT_DIR}/require_scratch
> > +	if grep -q "Operation not supported" $tmp.growfs; then
> > +		_notrun "growfs not supported on rt volume"
> > +	fi
> > +fi
> > +
> > +# Now that the root directory's extsize hint is no longer aligned to the rt
> > +# extent size, check that we don't report it to userspace any more.
> > +grow_extszhint=$($XFS_IO_PROG -c 'stat' $SCRATCH_MNT | \
> > +	grep 'fsxattr.extsize' | cut -d ' ' -f 3)
> > +test $grow_extszhint -eq 0 || \
> > +	echo "expected post-grow extszhint 0, got $grow_extszhint"
> > +
> > +# Check that we now have rt extents.
> > +rtextents=$($XFS_IO_PROG -c 'statfs' $SCRATCH_MNT | \
> > +	grep 'geom.rtextents' | cut -d ' ' -f 3)
> > +test $rtextents -gt 0 || echo "expected rtextents > 0"
> > +
> > +# Check the new rt extent size.
> > +after_rtextsz_blocks=$($XFS_IO_PROG -c 'statfs' $SCRATCH_MNT | \
> > +	grep 'geom.rtextsize' | cut -d ' ' -f 3)
> > +test $after_rtextsz_blocks -eq $new_rtextsz_blocks || \
> > +	echo "expected rtextsize $new_rtextsz_blocks, got $after_rtextsz_blocks"
> > +
> > +# Create a new realtime file to prove that we can.
> > +echo moo > $SCRATCH_MNT/a
> > +sync
> 
> A global sync is a bit heavy, fsync the file or syncfs $SCRATCH_MNT ?

Ok, I'll make that "sync -f $SCRATCH_MNT".

--D

> Thanks,
> Eryu
> 
> > +$XFS_IO_PROG -c 'lsattr -v' $SCRATCH_MNT/a | \
> > +	cut -d ' ' -f 1 | \
> > +	grep -q realtime || \
> > +	echo "$SCRATCH_MNT/a is not a realtime file?"
> > +
> > +# Check that the root directory's hint (which was aligned before the grow and
> > +# misaligned after) did not propagate to the new realtime file.
> > +file_extszhint=$($XFS_IO_PROG -c 'stat' $SCRATCH_MNT/a | \
> > +	grep 'fsxattr.extsize' | cut -d ' ' -f 3)
> > +test $file_extszhint -eq 0 || \
> > +	echo "expected file extszhint 0, got $file_extszhint"
> > +
> > +# success, all done
> > +echo Silence is golden
> > +status=0
> > +exit
> > diff --git a/tests/xfs/779.out b/tests/xfs/779.out
> > new file mode 100644
> > index 00000000..1f79fae2
> > --- /dev/null
> > +++ b/tests/xfs/779.out
> > @@ -0,0 +1,2 @@
> > +QA output created by 779
> > +Silence is golden
diff mbox series

Patch

diff --git a/tests/xfs/779 b/tests/xfs/779
new file mode 100755
index 00000000..f064879c
--- /dev/null
+++ b/tests/xfs/779
@@ -0,0 +1,112 @@ 
+#! /bin/bash
+# SPDX-License-Identifier: GPL-2.0
+# Copyright (c) 2021 Oracle.  All Rights Reserved.
+#
+# FS QA Test 779
+#
+# Test for xfs_growfs to make sure that we can add a realtime device and set
+# its extent size hint at the same time.  This also checks for the presence of
+# these patches:
+#
+#	xfs: improve FSGROWFSRT precondition checking
+#	xfs: fix an integer overflow error in xfs_growfs_rt
+#	xfs: correct the narrative around misaligned rtinherit/extszinherit dirs
+#	xfs: don't expose misaligned extszinherit hints to userspace
+#
+. ./common/preamble
+_begin_fstest auto quick realtime growfs
+
+# Import common functions.
+. ./common/filter
+
+# real QA test starts here
+
+# Modify as appropriate.
+_supported_fs generic
+_require_realtime
+_require_scratch
+
+# Format scratch fs with no realtime section.
+SCRATCH_RTDEV="" _scratch_mkfs | _filter_mkfs 2> $tmp.mkfs >> $seqres.full
+_scratch_mount
+
+# Check that there's no realtime section.
+source $tmp.mkfs
+test $rtblocks -eq 0 || echo "expected 0 rtblocks, got $rtblocks"
+
+# Compute a new rt extent size and a separate rt extent size hint to exercise
+# the code that ignores hints that aren't a multiple of the extent size.
+XFS_MAX_RTEXTSIZE=$((1024 * 1024 * 1024))
+new_rtextsz=$((rtextsz + dbsize))
+if [ $new_rtextsz -gt $XFS_MAX_RTEXTSIZE ]; then
+	new_rtextsz=$((rtextsz - dbsize))
+fi
+new_rtextsz_blocks=$(( new_rtextsz / dbsize ))
+
+new_extszhint=$((rtextsz * 2))
+if [ $new_extszhint -eq $new_rtextsz ]; then
+	new_extszhint=$((rtextsz * 3))
+fi
+
+# Set the inheritable extent size hint and rt status.
+$XFS_IO_PROG -c 'chattr +t' -c "extsize $new_extszhint" $SCRATCH_MNT
+
+# Check that the hint was set correctly
+after_extszhint=$($XFS_IO_PROG -c 'stat' $SCRATCH_MNT | \
+	grep 'fsxattr.extsize' | cut -d ' ' -f 3)
+test $after_extszhint -eq $new_extszhint || \
+	echo "expected extszhint $new_extszhint, got $after_extszhint"
+
+# Add a realtime section and change the extent size.
+echo $XFS_GROWFS_PROG -e $new_rtextsz_blocks -r $SCRATCH_MNT >> $seqres.full
+$XFS_GROWFS_PROG -e $new_rtextsz_blocks -r $SCRATCH_MNT >> $seqres.full 2> $tmp.growfs
+res=$?
+cat $tmp.growfs
+
+# If the growfs failed, skip the post-test check because the scratch fs does
+# not have SCRATCH_RTDEV configured.  If the kernel didn't support adding the
+# rt volume, skip everything else.
+if [ $res -ne 0 ]; then
+	rm -f ${RESULT_DIR}/require_scratch
+	if grep -q "Operation not supported" $tmp.growfs; then
+		_notrun "growfs not supported on rt volume"
+	fi
+fi
+
+# Now that the root directory's extsize hint is no longer aligned to the rt
+# extent size, check that we don't report it to userspace any more.
+grow_extszhint=$($XFS_IO_PROG -c 'stat' $SCRATCH_MNT | \
+	grep 'fsxattr.extsize' | cut -d ' ' -f 3)
+test $grow_extszhint -eq 0 || \
+	echo "expected post-grow extszhint 0, got $grow_extszhint"
+
+# Check that we now have rt extents.
+rtextents=$($XFS_IO_PROG -c 'statfs' $SCRATCH_MNT | \
+	grep 'geom.rtextents' | cut -d ' ' -f 3)
+test $rtextents -gt 0 || echo "expected rtextents > 0"
+
+# Check the new rt extent size.
+after_rtextsz_blocks=$($XFS_IO_PROG -c 'statfs' $SCRATCH_MNT | \
+	grep 'geom.rtextsize' | cut -d ' ' -f 3)
+test $after_rtextsz_blocks -eq $new_rtextsz_blocks || \
+	echo "expected rtextsize $new_rtextsz_blocks, got $after_rtextsz_blocks"
+
+# Create a new realtime file to prove that we can.
+echo moo > $SCRATCH_MNT/a
+sync
+$XFS_IO_PROG -c 'lsattr -v' $SCRATCH_MNT/a | \
+	cut -d ' ' -f 1 | \
+	grep -q realtime || \
+	echo "$SCRATCH_MNT/a is not a realtime file?"
+
+# Check that the root directory's hint (which was aligned before the grow and
+# misaligned after) did not propagate to the new realtime file.
+file_extszhint=$($XFS_IO_PROG -c 'stat' $SCRATCH_MNT/a | \
+	grep 'fsxattr.extsize' | cut -d ' ' -f 3)
+test $file_extszhint -eq 0 || \
+	echo "expected file extszhint 0, got $file_extszhint"
+
+# success, all done
+echo Silence is golden
+status=0
+exit
diff --git a/tests/xfs/779.out b/tests/xfs/779.out
new file mode 100644
index 00000000..1f79fae2
--- /dev/null
+++ b/tests/xfs/779.out
@@ -0,0 +1,2 @@ 
+QA output created by 779
+Silence is golden